"use strict";
/**
 * @author Olsi Rrjolli
 * This Class Represent the Controller for the Book Store. In this class are all endpoints defined
 */
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const typescript_ioc_1 = require("typescript-ioc");
const BookStoreService_1 = require("./BookStoreService");
const restified_aws_lambda_1 = require("restified-aws-lambda");
const BookStore_1 = require("./BookStore");
const Validator_1 = require("../../core/utils/Validator");
let BookStoreController = class BookStoreController {
    getBookStores() {
        return this.bookStoreService.getBookStores();
    }
    createBookStore(bookStore) {
        return this.bookStoreService.createBookStore(bookStore);
    }
    getBookStoreById(id) {
        Validator_1.default.validateField('id', id, Validator_1.default.VALIDATOR_SCHEMA.UUID_REQUIRED);
        return this.bookStoreService.getBookStoreById(id);
    }
    updateBookStore(bookStore, id) {
        Validator_1.default.validateField('id', id, Validator_1.default.VALIDATOR_SCHEMA.UUID_REQUIRED);
        // TODO valtdate the book store
        return this.bookStoreService.updateBookStore(bookStore, id);
    }
    deleteBookStore(id) {
        Validator_1.default.validateField('id', id, Validator_1.default.VALIDATOR_SCHEMA.UUID_REQUIRED);
        // TODO validate the book store
        return this.bookStoreService.deleteBookStore(id);
    }
};
__decorate([
    typescript_ioc_1.Inject,
    __metadata("design:type", BookStoreService_1.default)
], BookStoreController.prototype, "bookStoreService", void 0);
__decorate([
    restified_aws_lambda_1.GET(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], BookStoreController.prototype, "getBookStores", null);
__decorate([
    restified_aws_lambda_1.POST(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], BookStoreController.prototype, "createBookStore", null);
__decorate([
    restified_aws_lambda_1.GET('/{id}'),
    __param(0, restified_aws_lambda_1.PathParam('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], BookStoreController.prototype, "getBookStoreById", null);
__decorate([
    restified_aws_lambda_1.PUT('/{id}'),
    __param(1, restified_aws_lambda_1.PathParam('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", Promise)
], BookStoreController.prototype, "updateBookStore", null);
__decorate([
    restified_aws_lambda_1.DELETE('/{id}'),
    __param(0, restified_aws_lambda_1.PathParam('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], BookStoreController.prototype, "deleteBookStore", null);
BookStoreController = __decorate([
    typescript_ioc_1.Singleton,
    restified_aws_lambda_1.Model(BookStore_1.BookStore),
    restified_aws_lambda_1.Controller('/bookstores')
], BookStoreController);
exports.default = BookStoreController;
//# sourceMappingURL=BookStoreController.js.map