"use strict";
/**
 * @author Olsi Rrjolli
 * This Class represent the service layer for BookStore
 */
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const typescript_ioc_1 = require("typescript-ioc");
const uuid_1 = require("uuid");
const BookStoreRepository_1 = require("./BookStoreRepository");
class BookStoreService {
    getBookStores() {
        return this.bookStoreRepository.getBookStores();
    }
    createBookStore(bookStore) {
        bookStore.id = uuid_1.v4();
        bookStore.createdDate = new Date().toISOString();
        bookStore.lastModified = new Date().toISOString();
        bookStore.isDeleted = false;
        return this.bookStoreRepository.createBookStore(bookStore);
    }
    getBookStoreById(id) {
        return this.bookStoreRepository.getBookStoreById(id);
    }
    updateBookStore(bookStore, id) {
        bookStore.lastModified = new Date().toISOString();
        return this.bookStoreRepository.updateBookStore(bookStore, id);
    }
    deleteBookStore(id) {
        return this.bookStoreRepository.deleteBookStore(id);
    }
}
__decorate([
    typescript_ioc_1.Inject,
    __metadata("design:type", BookStoreRepository_1.default)
], BookStoreService.prototype, "bookStoreRepository", void 0);
exports.default = BookStoreService;
//# sourceMappingURL=BookStoreService.js.map