"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const restified_aws_lambda_1 = require("restified-aws-lambda");
const restified_aws_lambda_2 = require("restified-aws-lambda");
const restified_aws_lambda_3 = require("restified-aws-lambda");
require("reflect-metadata");
const BookStoreController_1 = require("./domains/book-store/BookStoreController");
// Register all Controllers
restified_aws_lambda_3.default.register(BookStoreController_1.default);
const response = new restified_aws_lambda_2.default();
/**
 * This method choose the right function to execute the http request for AWS, it is the entry method of the aws function
 * @param awsRequestEvent
 *  contains the httpMethod (get,post,delete,put) and the body of the request
 * @param context
 *  The AWS Context
 * @param callback
 *  The response callback
 *  first parameter is to throw an error from AWS.
 *  first parameter is undefined because if we want to use our error code to send it to the client
 */
function awsHandler(awsRequestEvent, context, callback) {
    restified_aws_lambda_1.execute(awsRequestEvent).then((result) => {
        // PUT SOME DEBUGGING LOGS HERE
        callback(undefined, response.getSuccessResponse(awsRequestEvent.httpMethod, result));
    }).catch((error) => {
        // PUT SOME DEBUGGING LOGS HERE
        callback(undefined, response.getErrorResponse(error));
    });
}
exports.awsHandler = awsHandler;
//# sourceMappingURL=index.js.map